###############################################
### Exercise 8-6  page 45 Johnson book ###
###############################################
# data in Exercise 1-4
x1 <- c(26.7, 38.4, 19.2, 20.6, 18.9, 14.8, 
	19, 14.2, 13.7, 7.7)
x2 <- c(3.3, 2.4, 1.7, 1, 0.9, 1, 2.7, 0.8, 
	1.1, 0.2)

data <- data.frame(x1 = x1, x2 = x2)
data
company <- c("MG", "EXzon", "Ford", "Mobile", 
	"Texzako", "STD", "IBM", "Golf", "GA", 
	"Crysler")

row.names(data) <- company

mean(data)
is.numeric(data)


as.numeric(data)

is.list(data)
mean(cbind(data$x1, data$x2))


xbar <- apply(data, 2, mean)
xbar

apply(data, 1, mean)

apply(data, 2, var)

S <- var(data)
S

###############################
### a
###########################
eigen(S)

lambda <- eigen(S)$values
e <- eigen(S)$vectors
e
e1 <- as.matrix(e[, 1])
e2 <- as.matrix(e[, 2])
e1
e2

data1 <- cbind(data$x1, data$x2)

y1 <- t((-1) * e1) %*% t(data1)

y2 <- t(e2) %*% t(data1)

e1[1] * x1[1] + e1[2] * x2[1]

###############
### b
##############
var(t(y1))
lambda[1]

var(t(y2))
lambda[2]

lambda[1]/sum(lambda)

lambda[2]/sum(lambda)
########################
### d
#####################

e1[1] * sqrt(lambda[1])/sqrt(var(x1))



#####################
### c
####################

#install.packages("ellipse",dep=T)
library(ellipse)

#Example 1: ellipse equation
#(x-Xbar)'S^(-1)(x-Xbar)=c^2
#c^2=1.4
c2 = 1.4
ellipse(S, centre = xbar, t = c2)

plot(ellipse(S, centre = xbar, t = c2))



plot(ellipse(S, centre = xbar, t = c2), type = "l", 
	xlim = c(7, 40), ylim = c(0, 4))

title("Ellipse plot")
points(x1, x2, pch = 16, col = 4)

points(xbar[1], xbar[2], pch = 18, col = 2)

text(xbar[1] + 1, xbar[2], expression(bar(x)), 
	col = 2, cex = 1)

text(x1, x2 + 0.1, company, col = "gray", cex = 0.8)

points(y1, y2, col = 3, pch = 9, cex = 1.2)

# confidence 95%
#(x-Xbar)'S^(-1)(x-Xbar)=c^2
#c^2=qchisq(0.95, 2)

plot(ellipse(S, centre = xbar, level = 0.95), 
	type = "l", xlim = c(7, 40), ylim = c(0, 
		4))
title("Ellipse plot")
points(x1, x2, pch = 16, col = 4)
points(xbar[1], xbar[2], pch = 18, col = 2)
text(xbar[1] + 1, xbar[2], expression(bar(x)), 
	col = 2, cex = 1)
text(x1, x2 + 0.1, company, col = "gray", cex = 0.8)


## two plots 
plot(ellipse(S, centre = xbar, level = 0.95), 
	type = "l")
title("Ellipse plot")
lines(ellipse(S, centre = xbar, t = c2), type = "l", 
	lty = 2, col = 2)

points(x1, x2, pch = 16, col = 4)
points(xbar[1], xbar[2], pch = 18, col = 2)
text(xbar[1] + 1, xbar[2], expression(bar(x)), 
	col = 2, cex = 1)
text(x1, x2 + 0.1, company, col = "gray", cex = 0.8)

legend("topleft", legend = c("95%", "c2=1.4"), 
	col = 1:2, lty = 1:2)
##############


pc <- princomp(data)
pc

summary(pc)
pc$loadings
names(pc)

screeplot(pc, col = "red", pch = 16, type = "lines", 
	cex = 2, lwd = 2, main = "")

biplot(pc, col = c(2, 3), cex = c(0.4, 1.5))

##################################################
S <- matrix(c(1, -2, 0, -2, 5, 0, 0, 0, 2), 
	3)
S
eigen(S)

#########################################
### data table 1.5 page 11 latin book ###
#########################################
getwd()
setwd("/Users/macbookpro/Bank-Mac/0-Desktop-2017/Pivaste-2-98/پیوسته 2")
T51 <- read.csv("table1-5-page11-latin.csv", 
	header = TRUE)
T51
T51[, 1]
apply(T51[, -1], 2, "mean")
data51 <- T51[, -1]
data51
row.names(data51) <- T51[, 1]
pc <- princomp(data51)
pc
S <- var(data51)
S
eigen(S)
summary(pc)
pc$loadings

screeplot(pc, col = "red", pch = 16, type = "lines", 
	cex = 2, lwd = 2, main = "")

biplot(pc, col = c(2, 3), cex = c(0.4, 1.5), 
	xlim = c(-0.45, 0.45))

###################################################
######### Chapter 9: Factor Analysis ##########
##########################################

## X-mu=LF+E
#E(F)=0, Cov(F)=I , E(E)=0, Cov(E)=Psi

## Sigma=LL'+Psi
## R=LL'+Psi    # for standard data

####################################
### Example 3-9 page 492 Johnson ###
####################################
r <- c(1, 0.02, 0.96, 0.42, 0.01, 0.02, 1, 
	0.13, 0.71, 0.85, 0.96, 0.13, 1, 0.5, 0.11, 
	0.42, 0.71, 0.5, 1, 0.79, 0.01, 0.85, 0.11, 
	0.79, 1)
R <- matrix(r, 5)
R

Lam <- eigen(R)
Lam

lambda <- Lam$values
lambda
e <- Lam$vectors
e
######### principal component methods
L11 <- sqrt(lambda[1]) * e[1, 1]

sqrt(lambda[1]) * e[, 1]
sqrt(lambda[2]) * e[, 2]

L <- cbind(sqrt(lambda[1]) * e[, 1], sqrt(lambda[2]) * 
	e[, 2])
L
round(L,2)

round(R - L %*% t(L), 2)

diag(round(R - L %*% t(L), 2))


Psi <- diag(diag(round(R - L %*% t(L), 2)))
Psi

Rhat<-L %*% t(L) + Psi

round(R-Rhat,2)

round(L %*% t(L) + Psi, 2)

L1 <- sqrt(lambda[1]) * e[, 1]
L1
L2 <- sqrt(lambda[2]) * e[, 2]
L2

hi2 <- diag(L %*% t(L))
hi2
round(hi2,2)

Psi.i <- 1 - hi2
Psi.i
round(Psi.i,2)

lambda[1]/5
(lambda[1]+lambda[2])/5
#####################################################
# function in R is: factanal
# always mle methods
?factanal

M<-factanal(factors=2,covmat=R,cor=TRUE,rotation="none")
M

L <- M$loadings
L
Psi <- diag(M$uniquenesses)
R1 <- M$correlation
Rhat <- L %*% t(L) + Psi
Rhat

round(R1 - Rhat, 2)
#######################
# install.packages("psych",dep=T)
library(psych)
?fa

M1 <- fa(r=R, nfactors=2, rotate="none", fm = "pa")
M1

plot(M1,cex=.7) 
# mle
M2 <- fa(r = R, nfactors = 2,rotate = "none",fm = "mle")
M2
plot(M2,cex=.7)

## rotate=varimax
M2 <- fa(r=R, nfactors=2, rotate="varimax", fm = "pa")
M2

par(mfrow=c(1,2))
plot(M1,cex=.7) 
plot(M2,cex=.7,ylim=c(-.2,1)) 
 
####################################
### Example 4-9 page 493 Johnson ###
####################################
# load data table 8-1 pages 472
data81<-read.csv( "table8-1.csv",head=T )
head(data81)

R<-cov(data81)
#eigen

Lam <- eigen(R)
Lam

lambda <- Lam$values
lambda
e <- Lam$vectors
e
######### principal component methods

L <- cbind(sqrt(lambda[1]) * e[, 1], sqrt(lambda[2]) * 
	e[, 2])
L
round(L,2)

round(R - L %*% t(L), 2)

diag(round(R - L %*% t(L), 2))




############
M<-fa(data81, nfactors = 1, rotate = "none", fm = "pa")
M

M<-fa(data81, nfactors = 2, rotate = "none", fm = "pa")
M

###############


#######################
# example 6-9 page 500
#######################
????

####################################
### Example 8-9 page 509 Johnson ###
####################################
r1<-c(1,0.439,0.41,0.288,0.329,0.248)
r2<-c(0.439,1,0.351,0.354,0.32,0.329)
r3<-c(0.41,0.351,1,0.164,0.19,0.181)
r4<-c(0.288,0.354,0.164,1,0.595,0.47)
r5<-c(0.329,0.32,0.19,0.595,1,0.464)
r6<-c(0.248,0.329,0.181,0.47,0.464,1)

R<-rbind(r1,r2,r3,r4,r5,r6)
R
colnames(R)<-c("Irlandi","Eng","History","Calculus","Algebra","geometry")
R
rownames(R)<-c("Irlandi","Eng","History","Calculus","Algebra","geometry")
R

M<-fa(r=R, nfactors = 2, rotate = "none", fm = "pa")
M

names(M)

M$loadings
L<-M$loadings
L


M$communality   # h2
M$uniquenesses
M$R2.scores
M$residual   # R-LL'

Psi<-diag(M$uniquenesses)

Rhat<-L%*%t(L)+Psi
Rhat
R
# errors
R-Rhat

# MSE 
MSE<-mean((R-Rhat)^2)
MSE

# MAD
MAD<-mean(abs(R-Rhat))
MAD


# rotate varimax
M1<-fa(r=R, nfactors = 2, rotate = "varimax", fm = "pa")
M1

par(mfrow=c(1,2))
plot(M,ylim=c(-.5,.5))
text(.45,-.4,"no rotate",col=2)
plot(M1,ylim=c(-.1,.7))
text(.2,.2,"rotate varimax",col=2)
############### mle
M<-fa(r=R, nfactors = 2, rotate = "none", fm = "mle")
M

names(M)
M$loadings
L<-M$loadings
L

M$communality   # h2
M$uniquenesses  # u2
M$R2.scores
M$residual   # R-LL'

Psi<-diag(M$uniquenesses)
Rhat<-L%*%t(L)+Psi
Rhat
# errors
R-Rhat

# rotate varimax
M1<-fa(r=R, nfactors = 2, rotate = "varimax", fm = "mle")
M1

par(mfrow=c(1,2))
plot(M,ylim=c(-.5,.5))
plot(M1,ylim=c(-.1,.7))


# MSE 
MSE.mle<-mean((R-Rhat)^2)
MSE.mle

# MAD
MAD.mle<-mean(abs(R-Rhat))
MAD.mle



#######################
# example 10-9 page 513
#######################
????




#########################
# Exercies 10.9 page 546
#########################
c1<-c(1,0.505,0.569,0.602,0.621,0.603)
c2<-c(0.505,1,0.422,0.467,0.482,0.45)
c3<-c(0.569,0.422,1,0.926,0.877,0.878)
c4<-c(0.602,0.467,0.926,1,0.874,0.894)
c5<-c(0.621,0.482,0.877,0.874,1,0.937)
c6<-c(0.603,0.45,0.878,0.894,0.937,1)

R<-cbind(c1,c2,c3,c4,c5,c6)

R

M<-fa(r=R,nfactors=2,rotate="none",fm="mle")
M

#a)
u2<-M$uniquenesses # u2
u2
Psi<-diag(M$uniquenesses)
### b)
h2<-M$communality   # h2
h2
1-u2

### c)

L<-M$loadings
L

## d)

#errors
Rhat<-L%*%t(L)+Psi
R-Rhat

MAD<-mean(abs(R-Rhat))
MAD

######## 11.9

M1<-fa(r=R,nfactors=2,rotate="varimax",fm="mle")
M1


par(mfrow=c(1,2))
plot(M,ylim=c(-.5,.5))
text(.6,.2,"no rotate",col=2)
plot(M1,ylim=c(-.1,.7))
text(.6,.2,"rotate varimax",col=2)
#a)
u2<-M1$uniquenesses # u2
u2
Psi<-diag(M1$uniquenesses)
### b)
h2<-M1$communality   # h2
h2
1-u2

### c)

L<-M1$loadings
L

## d)

#errors
Rhat<-L%*%t(L)+Psi
R-Rhat

MAD1<-mean(abs(R-Rhat))
MAD1

